<template>
  <v-card class="elevation-12">
    <v-toolbar color="primary" dark flat>
      <v-toolbar-title>{{isRegisterModal ? "Inscription" :"Connexion" }}</v-toolbar-title>
      <v-spacer></v-spacer>
    </v-toolbar>
    <v-card-text>
      <v-row dense align="center" justify="center">
        <v-col cols="12" md="8">
          <ValidationObserver ref="observer" v-if="!isRegisterModal">
            <v-form>
              <ValidationProvider v-slot="{ errors }" name="loginEmail" rules="required">
                <v-text-field label="Email" name="Email" prepend-icon="mdi-account" type="text" :error-messages="errors" v-model="loginFormData.login"></v-text-field>
              </ValidationProvider>
              <ValidationProvider v-slot="{ errors }" name="loginPassword" rules="required">
                <v-text-field label="Mot de passe" name="password" prepend-icon="mdi-lock" type="password" :error-messages="errors" v-model="loginFormData.password"></v-text-field>
              </ValidationProvider>
            </v-form>
          </ValidationObserver>
          <ValidationObserver ref="observer" v-else>
            <v-form>
              <v-row>
                <v-col cols="12" md="6">
                  <ValidationProvider v-slot="{ errors }" name="registerEmail" rules="required">
                    <v-text-field v-model="registerFormData.email" prepend-icon="mdi-account" label="Email" required :error-messages="errors"></v-text-field>
                  </ValidationProvider>
                  <ValidationProvider v-slot="{ errors }" name="registerPassword" rules="required">
                    <v-text-field v-model="registerFormData.password" prepend-icon="mdi-lock" type="password" label="Mot de passe" required :error-messages="errors"></v-text-field>
                  </ValidationProvider>
                  <ValidationProvider v-slot="{ errors }" name="registerConfirmPassword" rules="required">
                    <v-text-field v-model="registerFormData.passwordConfirm" prepend-icon="mdi-lock" type="password" :rules="[emailMatch]" label="Confirmation du mot de passe" required :error-messages="errors"></v-text-field>
                  </ValidationProvider>
                </v-col>
                <v-col cols="12" md="6">
                  <ValidationProvider v-slot="{ errors }" name="registerFirstname" rules="required">
                    <v-text-field v-model="registerFormData.firstname" prepend-icon="mdi-face" label="Prénom" required :error-messages="errors"></v-text-field>
                  </ValidationProvider>
                  <ValidationProvider v-slot="{ errors }" name="registerLastname" rules="required">
                    <v-text-field v-model="registerFormData.lastname" prepend-icon="mdi-face-profile" label="Nom" required :error-messages="errors"></v-text-field>
                  </ValidationProvider>
                  <ValidationProvider v-slot="{ errors }" name="registerBirthdate" rules="required">
                    <v-text-field v-model="registerFormData.birthdate" prepend-icon="mdi-cake-variant" type="date" label="Date de naissance" required :error-messages="errors"></v-text-field>
                  </ValidationProvider>
                </v-col>
              </v-row>
            </v-form>
          </ValidationObserver>
        </v-col>
        <v-col cols="12" md="4" class="text-center">
          <v-btn color="secondary" outlined @click="isRegisterModal = !isRegisterModal">{{ isRegisterModal ? "Se connecter"  : "S'inscrire"}}</v-btn>
        </v-col>
      </v-row>
    </v-card-text>
    <v-card-actions>
      <v-spacer></v-spacer>
      <v-btn color="primary" @click="submitForm">{{ isRegisterModal ? "S'inscrire" : "Se connecter" }}</v-btn>
    </v-card-actions>
  </v-card>
</template>
<script lang="ts">
import Vue from "vue";
import Component from "vue-class-component";
import { Prop } from "vue-property-decorator";
import AuthService from "../../../services/AuthService";
import UserService from "../../../services/UserService";

@Component
export default class LoginForm extends Vue {
  @Prop({ type: Boolean, required: false, default: false })
  isFromModal;

  authService: AuthService = null;
  userService: UserService = null;

  loginFormData = {
    login: "",
    password: "",
  };
  registerFormData = {
    email: "",
    password: "",
    passwordConfirm: "",
    firstname: "",
    lastname: "",
    birthdate: "",
  };

  isRegisterModal: boolean = false;

  emailMatch = () => {
    return (
      this.registerFormData.password ===
        this.registerFormData.passwordConfirm ||
      "Les mot de passe ne correspondent pas"
    );
  };

  mounted() {
    this.authService = new AuthService();
    this.userService = new UserService();
  }

  submitForm() {
    if (this.isRegisterModal) {
      this.userService
        .createUser(
          this.registerFormData.email,
          this.registerFormData.firstname,
          this.registerFormData.lastname,
          this.registerFormData.birthdate,
          this.registerFormData.password
        )
        .then(() => {
          this.handleSuccess();
        });
    } else {
      this.authService
        .login(this.loginFormData.login, this.loginFormData.password)
        .then(() => {
          this.handleSuccess();
        });
    }
  }
  handleSuccess() {
    this.Toast.success(this.isRegisterModal ? "Compte créé avec succès" : "Connecté");
    Vue.nextTick(() => {
      if (this.isRegisterModal) {
        this.loginFormData.login = this.registerFormData.email;
        this.loginFormData.password = "" ;
        this.isRegisterModal = false;
        }
      else {
        if (this.isFromModal) this.$store.dispatch("hideLoginModal");
        else this.$router.push({ name: "home" });
      }
    });
  }
}
</script>
